﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using ff14bot.Managers;
using ff14bot.Helpers;
using System.Windows.Media;

namespace GrandCompanySealsSpenderPlugin
{
    public partial class Gui : Form
    {
        private static List<string> Rank1Weapons = new List<string>();
        private static List<string> Rank2Weapons = new List<string>();
        private static List<string> Rank3Weapons = new List<string>();
        private static List<string> Rank1Armor = new List<string>();
        private static List<string> Rank2Armor = new List<string>();
        private static List<string> Rank3Armor = new List<string>();
        private static List<string> Rank1Items = new List<string>();
        private static List<string> Rank2Items = new List<string>();
        private static List<string> Rank3Items = new List<string>();

        public void FillLists()
        {
            int index = 0;
            Rank1Weapons.Add("None");
            Rank2Weapons.Add("None");
            Rank3Weapons.Add("None");
            Rank1Armor.Add("None");
            Rank2Armor.Add("None");
            Rank3Armor.Add("None");
            Rank1Items.Add("None");
            Rank2Items.Add("None");
            Rank3Items.Add("None");

            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");
            index++;
            Rank1Items.Add(index + "");

            index = 0;
            index++;
            Rank2Items.Add(index + "");
            index++;
            Rank2Items.Add(index + "");
            index++;
            Rank2Items.Add(index + "");
            index++;
            Rank2Items.Add(index + " Company-issue Engineering Manual II");
            index++;
            Rank2Items.Add(index + " Company-issue Survival Manual II");
            index++;
            Rank2Items.Add(index + " Sanction");
            index++;
            Rank2Items.Add(index + "");
            index++;
            Rank2Items.Add(index + " Cordial");
            index++;
            Rank2Items.Add(index + " Durability Draught");
            index++;
            Rank2Items.Add(index + " Spiritbond Potion");

            index = 0;
            while (index < 51)
            {
                index++;
                if (index == 5)
                {
                    Rank3Items.Add(index + " Coke");
                }
                else if (index == 21)
                {
                    Rank3Items.Add(index + " Dalamud Popoto");
                }
                else
                {
                    Rank3Items.Add(index + "");
                }
            }
        }

        public List<string> SelectList(int Rank, int Type)
        {
            string RankType = Rank + "," + Type;
            switch (RankType)
            {
                case "0,0":
                    return Rank1Items;
                case "1,0":
                    return Rank2Items;
                case "2,0":
                    return Rank3Items;
                case "0,1":
                    return Rank1Weapons;
                case "1,1":
                    return Rank2Weapons;
                case "2,1":
                    return Rank3Weapons;
                case "0,2":
                    return Rank1Armor;
                case "1,2":
                    return Rank2Armor;
                case "2,2":
                    return Rank3Armor;
            }
            Logging.Write(Colors.Aqua, "[GrandCompanySealsSpenderPlugin] Please select a new Grand Company Item from the settings window to spend seals on.");
            return null;
        }

        public Gui()
        {
            //System.Diagnostics.Debugger.Break();
            InitializeComponent();

            FillLists();

            /*var medicineitems = MedicineList().ToList();
            medicineitems.Insert(0, "None");*/
            comboBoxName.DataSource = SelectList(Settings.Instance.ItemRank, Settings.Instance.ItemType);

            if (Settings.Instance.ItemName != null && comboBoxName.Items.Contains(Settings.Instance.ItemName))
            {
                comboBoxName.SelectedIndex = Settings.Instance.ItemNameIndex + 1;
            }
            else
            {
                if (comboBoxName.Items.Count != 0) comboBoxName.SelectedIndex = 0;
                Settings.Instance.ItemName = null;
                Settings.Instance.Save();
            }

            numericUpDownSealsExceed.Value = Settings.Instance.SealsExceed;
            numericUpDownSealsBelow.Value = Settings.Instance.SealsBelow;
            numericUpDownVendorDelay.Value = Settings.Instance.VendorDelay;
            comboBoxRank.SelectedIndex = Settings.Instance.ItemRank;
            comboBoxType.SelectedIndex = Settings.Instance.ItemType;
            comboBoxName.DataSource = SelectList(Settings.Instance.ItemRank, Settings.Instance.ItemType);

            /*if (Settings.Instance.ItemName != null && comboBoxRank.Items.Contains(Settings.Instance.ItemName))
            {
                comboBoxName.SelectedItem = Settings.Instance.ItemName;
            }
            else
            {
                comboBoxName.SelectedItem = "None";
                Settings.Instance.ItemName = null;
                Settings.Instance.Save();
            }*/
        }

        private void comboBoxName_SelectionChangeCommitted(object sender, EventArgs e)
        {
            comboBoxNameSelectionChangeCommitted();
        }

        private void comboBoxNameSelectionChangeCommitted()
        {
            if (comboBoxName.SelectedValue != null) Settings.Instance.ItemName = comboBoxName.SelectedValue.ToString();
            if (Settings.Instance.ItemName == "None") { Settings.Instance.ItemName = null; }
            Settings.Instance.ItemNameIndex = comboBoxName.SelectedIndex - 1;
            Settings.Instance.Save();
        }

        private void comboBoxName_DropDown(object sender, EventArgs e)
        {
            comboBoxRank.DataSource = null;
            //var medicineitems = MedicineList().ToList();
            //medicineitems.Insert(0, "None");
            comboBoxName.DataSource = SelectList(Settings.Instance.ItemRank, Settings.Instance.ItemType);
        }

        private void comboBoxRank_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (Settings.Instance.ItemRank != comboBoxRank.SelectedIndex)
            {
                Settings.Instance.ItemRank = comboBoxRank.SelectedIndex;
                comboBoxRank.DataSource = null;
                comboBoxName.DataSource = SelectList(Settings.Instance.ItemRank, Settings.Instance.ItemType);
                comboBoxName.SelectedIndex = 0;
                Settings.Instance.Save();
                comboBoxNameSelectionChangeCommitted();
            }
        }

        private void comboBoxType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (Settings.Instance.ItemType != comboBoxType.SelectedIndex)
            {
                Settings.Instance.ItemType = comboBoxType.SelectedIndex;
                comboBoxRank.DataSource = null;
                comboBoxName.DataSource = SelectList(Settings.Instance.ItemRank, Settings.Instance.ItemType);
                comboBoxName.SelectedIndex = 0;
                Settings.Instance.Save();
                comboBoxNameSelectionChangeCommitted();
            }
        }

        private void numericUpDownSealsExceed_ValueChanged(object sender, EventArgs e)
        {
            if (numericUpDownSealsExceed.Value <= numericUpDownSealsBelow.Value) numericUpDownSealsExceed.Value = numericUpDownSealsBelow.Value + 1;
            Settings.Instance.SealsExceed = (int)numericUpDownSealsExceed.Value;
            Settings.Instance.Save();
        }

        private void numericUpDownSealsBelow_ValueChanged(object sender, EventArgs e)
        {
            if (numericUpDownSealsBelow.Value >= numericUpDownSealsExceed.Value) numericUpDownSealsBelow.Value = numericUpDownSealsExceed.Value - 1;
            Settings.Instance.SealsBelow = (int)numericUpDownSealsBelow.Value;
            Settings.Instance.Save();
        }

        private void buttonSpendSeals_Click(object sender, EventArgs e)
        {
            GrandCompanySealsSpenderPlugin.SpendGCSealsButtonPressed();
        }

        private void numericUpDownVendorDelay_ValueChanged(object sender, EventArgs e)
        {
            Settings.Instance.VendorDelay = (int)numericUpDownVendorDelay.Value;
            Settings.Instance.Save();
        }
    }
}